<template>
  <div
    v-for="(promotion, index) in promotionListForDisplay"
    :key="index"
    class="p-[15px] flex items-start justify-center gap-[10px] w-[1100px] promotion-details"
  >
    <div class="w-[840px] flex flex-col justify-start h-fit">
      <img class="w-[840px] h-[200px]" :src="promotion.ImagePathForDisplay" />
      <div :class="`promotion-info ${promotion.IsVisible ? 'active' : ''}`">
        <div
          class="promotion-info-inner flex flex-col items-start justify-start"
        >
          <span class="promotion-title"
            >{{ promotion.Title }} ({{ promotion.PromoCode }})</span
          >
          <span class="promotion-remark">{{ promotion.Remark }}</span>
          <span v-html="promotion.Content" class="promotion-content"></span>
        </div>
      </div>
    </div>
    <div
      class="w-[210px] h-[200px] flex flex-col items-end justify-start gap-2 promotion-action"
    >
      <el-button
        class="w-[210px] more-info"
        type="primary"
        @click="onMoreInfoClick(promotion)"
        >{{ $t("more_info") }}</el-button
      >
      <el-button
        class="w-[210px] apply"
        type="primary"
        v-if="promotion.IsAbleToApply"
        @click="onApply(promotion)"
        >{{ $t("apply") }}</el-button
      >
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import { IPromotion, Promotion } from "@/models/promotion/promotion";

export default defineComponent({
  name: "PromotionItemsRender",
  props: {
    promotionList: {
      type: Array as PropType<Array<IPromotion>>,
      default: () => [],
    },
    selectModel: {
      type: Number,
      default: 0,
    },
    radioModel: {
      type: String,
      default: "all",
    },
    isAuthenticated: {
      type: Boolean,
      default: false,
    },
  },
  emits: ["onApply"],
  setup(props, { emit }) {
    const router = useRouter();
    const promotionListForDisplay = computed(() => {
      if (props.radioModel === "product_type") {
        if (props.selectModel === 0) {
          return props.promotionList;
        }
        return props.promotionList.filter(
          (promotion) => promotion.ProductType === props.selectModel
        );
      }
      if (props.radioModel === "promotion_type") {
        return props.promotionList.filter(
          (promotion) => promotion.PromotionTypeId === props.selectModel
        );
      }
      return props.promotionList;
    });
    const onMoreInfoClick = (param: Promotion) => {
      param.IsVisible = !param.IsVisible;
    };
    const onApply = (param: IPromotion) => {
      if (props.isAuthenticated) {
        emit("onApply", param.Id);
      } else {
        router.push("/login");
      }
    };
    return {
      promotionListForDisplay,
      onMoreInfoClick,
      onApply,
    };
  },
});
</script>

<style lang="scss" scoped>
.promotion-details {
  .promotion-info {
    max-height: 0vh;
    transition: 0.3s ease-in-out;
    overflow: hidden;
    border: 0px dashed black;
    border-top: none;

    .promotion-info-inner {
      margin: 10px 0px 10px 10px;

      .promotion-title {
        color: red;
        font-weight: 700;
        font-size: 1.125rem;
      }
      .promotion-remark {
        font-size: 1.125rem;
      }
      .promotion-content {
        margin-top: 5px;
        font-size: 12px;
        color: #999;
      }
    }
  }
  .active {
    max-height: 100vh;
    overflow: auto;
    border: 1px dashed black;
    border-top: none;
  }
  .promotion-info::-webkit-scrollbar {
    width: 0px;
  }
  .promotion-action {
    .more-info {
      --el-button-bg-color: rgb(52, 144, 220);
      --el-button-hover-bg-color: rgb(33, 38, 131);
    }
    .apply {
      --el-button-bg-color: rgb(40, 46, 146);
      --el-button-hover-bg-color: rgb(19, 23, 92);
    }
  }
}
</style>
